// exec-beispiele.c
// Betriebssysteme 1, v0.1, 2024-04-23

#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>

void execv_test () {
  char *path = "/usr/bin/head";
  char *args[] = {
    "head",
    "-1",
    "/etc/os-release",
    NULL
  };
  execv (path, args);
}

void execl_test () {
  execl ("/usr/bin/head", 
    "head",
    "-1",
    "/etc/os-release",
    NULL);
}

void execle_test () {
  char *s = getenv("HOME");
  printf ("HOME = %s\n", s);

  char *env[] = { "HOME=/test/xyz", NULL };
  execle ("./printhome", "printhome", NULL, env);
}

int main () {
  int pid;

  // execv-Test
  pid=fork(); if (pid==0) execv_test(); else wait(NULL);

  // execl-Test
  pid=fork(); if (pid==0) execl_test(); else wait(NULL);

  // execle-Test
  pid=fork(); if (pid==0) execle_test(); else wait(NULL);
}
